﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Security.Cryptography;
using System.IO;
using libMpSDK;
using System.Net.Mail;

namespace MP_SDK_Demo
{
    public partial class frmMain : Form
    {
        // SDK Lib
        public cls_MP_SDK g_objSDK;
        
        private frmISO14443A_GetUID m_objISO14443A_GetUID = new frmISO14443A_GetUID();
        private frmISO14443A_RATS m_objISO14443A_RATS = new frmISO14443A_RATS();
        private frmISO14443A_APDU m_objISO14443A_APDU = new frmISO14443A_APDU();
        private frmISO14443A_Deselect m_objISO14443A_Deselect = new frmISO14443A_Deselect();
        private frmISO14443A_ReadMifare m_objISO14443A_ReadMifare = new frmISO14443A_ReadMifare();
        private frmISO14443A_WriteMifare m_objISO14443A_WriteMifare = new frmISO14443A_WriteMifare();
        private frmISO14443A_Ultralight_Read m_objISO14443A_Ultralight_Read = new frmISO14443A_Ultralight_Read();
        private frmISO14443A_Ultralight_Write m_objISO14443A_Ultralight_Write = new frmISO14443A_Ultralight_Write();
        private frmISO14443A_UltralightC_Auth m_objISO14443A_UltralightC_Auth = new frmISO14443A_UltralightC_Auth();
        private frmISO14443A_UltralightC_Read m_objISO14443A_UltralightC_Read = new frmISO14443A_UltralightC_Read();
        private frmISO14443A_UltralightC_Write m_objISO14443A_UltralightC_Write = new frmISO14443A_UltralightC_Write();
        private frmTopaz_GetUID m_objTopaz_GetUID = new frmTopaz_GetUID();
        private frmTopaz_ReadBlock m_objTopaz_ReadBlock = new frmTopaz_ReadBlock();
        private frmTopaz_WriteBlock m_objTopaz_WriteBlock = new frmTopaz_WriteBlock();
        private frmPayWave_GetUID m_objPayWave_GetUID = new frmPayWave_GetUID();

        private frmISO14443B_GetUID m_objISO14443B_GetUID = new frmISO14443B_GetUID();
        private frmISO14443B_ATTRIB m_objISO14443B_ATTRIB = new frmISO14443B_ATTRIB();
        private frmISO14443B_APDU m_objISO14443B_APDU = new frmISO14443B_APDU();
        private frmISO14443B_Deselect m_objISO14443B_Deselect = new frmISO14443B_Deselect();
        private frmISO14443B_GetUID_Cepas m_objISO14443B_Cepas_GetUID = new frmISO14443B_GetUID_Cepas();
        private frmISO14443B_SRI_GetUID m_objISO14443B_SRI_GetUID = new frmISO14443B_SRI_GetUID();
        private frmISO14443B_SRI_ReadBlock m_objISO14443_SRI_ReadBlock = new frmISO14443B_SRI_ReadBlock();
        private frmISO14443B_SRI_WriteBlock m_objISO14443_SRI_WriteBlock = new frmISO14443B_SRI_WriteBlock();
        private frmISO14443B_PayWave_GetUID m_objISO14443_PayWave_GetUID = new frmISO14443B_PayWave_GetUID();

        private frmISO15693_GetUID m_objISO15693_GetUID = new frmISO15693_GetUID();
        private frmISO15693_ReadBlock m_objISO15693_ReadBlock = new frmISO15693_ReadBlock();
        private frmISO15693_WriteBlock m_objISO15693_WriteBlock = new frmISO15693_WriteBlock();

        private frmPicoTag_GetUID m_objPicoTag_GetUID = new frmPicoTag_GetUID();
        private frmPicoTag_ReadBlock m_objPicotag_Read = new frmPicoTag_ReadBlock();

        private frmISO7816_GetATS m_objISO7816_GetATS = new frmISO7816_GetATS();
        private frmISO7816_APDU m_objISO7816_APDU = new frmISO7816_APDU();
        private frmISO7816_Special_HealthIC_Taiwan m_objISO7816_Special_TaiwanHealthIC = new frmISO7816_Special_HealthIC_Taiwan();

        private frmFelica_GetUID m_objFelica_GetUID = new frmFelica_GetUID();

        private frmDesfire_GetVersion m_objDesfire_GetVersion = new frmDesfire_GetVersion();
        private frmDesfire_SelectApplication m_objDesfire_SelectApplication = new frmDesfire_SelectApplication();
        private frmDesfire_GetKeyVersion m_objDesfire_GetKeyVersion = new frmDesfire_GetKeyVersion();
        private frmDesfire_GetKeySetting m_objDesfire_GetKeySetting = new frmDesfire_GetKeySetting();
        private frmDesfire_Authenticate m_objDesfire_Authenticate = new frmDesfire_Authenticate();
        private frmDesfire_GetApplicationIDS m_objDesfire_GetApplicationIDS = new frmDesfire_GetApplicationIDS();
        private frmDesfire_DeleteApplication m_objDesfire_DeleteApplication = new frmDesfire_DeleteApplication();
        private frmDesfire_CreateApplication m_objDesfire_CreateApplication = new frmDesfire_CreateApplication();
        private frmDesfire_FreeMemory m_objDesfire_FreeMemory = new frmDesfire_FreeMemory();
        private frmDesfire_FormatPICC m_objDesfire_FormatPICC = new frmDesfire_FormatPICC();
        private frmDesfire_ChangeKeySettings m_objDesfire_ChangeKeySettings = new frmDesfire_ChangeKeySettings();
        private frmDesfire_ChangeKey m_objDesfire_ChangeKey = new frmDesfire_ChangeKey();
        private frmDesfire_GetFileIDS m_objDesfire_GetFileIDs = new frmDesfire_GetFileIDS();
        private frmDesfire_CreateStdDataFile m_objDesfire_CreateStdDataFile = new frmDesfire_CreateStdDataFile();
        private frmDesfire_DeleteFile m_objDesfire_DeleteFile = new frmDesfire_DeleteFile();
        private frmDesfire_CreateBackupDataFile m_objDesfire_CreateBackupDataFile = new frmDesfire_CreateBackupDataFile();
        private frmDesfire_CreateValueFile m_objDesfire_CreateValueFile = new frmDesfire_CreateValueFile();
        private frmDesfire_CreateLinearRecordFile m_objDesfire_CreateLinearRecordFile = new frmDesfire_CreateLinearRecordFile();
        private frmDesfire_CreateCyclicRecordFile m_objDesfire_CreateCyclicRecordFile = new frmDesfire_CreateCyclicRecordFile();
        private frmDesfire_GetFileSetting m_objDesfire_GetFileSetting = new frmDesfire_GetFileSetting();
        private frmDesfire_ChangeFileSetting m_objDesfire_ChangeFileSetting = new frmDesfire_ChangeFileSetting();
        private frmDesfire_CommitTransaction m_objDesfire_CommitTransaction = new frmDesfire_CommitTransaction();
        private frmDesfire_AbortTransaction m_objDesfire_AbortTransaction = new frmDesfire_AbortTransaction();
        private frmDesfire_GetValue m_objDesfire_GetValue = new frmDesfire_GetValue();
        private frmDesfire_Credit m_objDesfire_Credit = new frmDesfire_Credit();
        private frmDesfire_Dedit m_objDesfire_Debit = new frmDesfire_Dedit();
        private frmDesfire_LimitedCredit m_objDesfire_LimitedCredit = new frmDesfire_LimitedCredit();
        private frmDesfire_ReadRecords m_objDesfire_ReadRecords = new frmDesfire_ReadRecords();
        private frmDesfire_WriteRecords m_objDesfire_WriteRecords = new frmDesfire_WriteRecords();
        private frmDesfire_ClearRecordFile m_objDesfire_ClearRecordFile = new frmDesfire_ClearRecordFile();
        private frmDesfire_WriteData m_objDesfire_WriteData = new frmDesfire_WriteData();
        private frmDesfire_ReadData m_objDesfire_ReadData = new frmDesfire_ReadData();

        private frmP2P_SendData m_objP2P_SendData = new frmP2P_SendData();

        private Boolean m_bSettingProtocol;

        private void UART_RX(object sender, EventArgs e)
        {
            txtCommunicationLogs.Text = g_objSDK.CommunicationLogs;

            if (m_bSettingProtocol == true) return;
            // Protocol Type
            try
            {
                switch (tabMain.SelectedIndex)
                {
                    case 0:
                        Show_ISO14443A_Result();
                        break;

                    case 1:
                        Show_ISO14443B_Result();
                        break;

                    case 2:
                        Show_ISO15639_Result();
                        break;

                    case 3:
                        Show_PicoTag_Result();
                        break;

                    case 4:
                        Show_Felica_Result();
                        break;
                }
            }
            catch { return; }
        }

        private void UART_TX(object sender, EventArgs e)
        {
            txtCommunicationLogs.Text = g_objSDK.CommunicationLogs;
        }

        // Show ISO14443A Command Result
        private void Show_ISO14443A_Result()
        { 
            //
            switch (trvISO14443A.SelectedNode.Name)
            {
                // Get UID
                case "Standard_GetUID":
                    m_vResult_ISO14443A_GetUID();
                    break;

                // RATS
                case "Standard_RATS":
                    m_vResult_ISO14443A_RATS();
                    break;

                // APDU
                case "Standard_APDU":
                    m_vResult_ISO14443A_APDU();
                    break;

                // Deselect
                case "Standard_Deselect":
                    m_vResult_ISO14443A_Deselect();
                    break;

                // Read Mifare
                case "Mifare_Read":
                    m_vResult_ISO14443A_ReadMifare();
                    break;

                // Write Mifare
                case "Mifare_Write":
                    m_vResult_ISO14443A_WriteMifare();
                    break;

                // Ultralight Read
                case "Ultralight_Read":
                    m_vResult_ISO14443A_Ultralight_ReadPage();
                    break;

                // Ultralight Write
                case "Ultralight_Write":
                    m_vResult_ISO14443A_Ultralight_WritePage();
                    break;

                // Ultralight C Authenticate
                case "UltralightC_Auth":
                    m_vResult_ISO14443A_UltralightC_Auth();
                    break;

                // Ultralight C Read
                case "UltralightC_Read":
                    m_vResult_ISO14443A_UltralightC_ReadPage();
                    break;

                // Ultralight Write
                case "UltralightC_Write":
                    m_vResult_ISO14443A_UltralightC_WritePage();
                    break;

                // Desfire Get Version
                case "DS_PICC_GetVersion":
                    m_vResult_Desfire_GetVersion();
                    break;

                // Desfire Select Application
                case "DS_PICC_SelectApplication":
                    m_vResult_Desfire_SelectApplication();
                    break;

                // Desfire Get Key Version
                case "DS_Security_GetKeyVersion":
                    m_vResult_Desfire_GetKeyVersion();
                    break;

                // Desfire Get Key Setting
                case "DS_PICC_GetKeySettings":
                    m_vResult_Desfire_GetKeySetting();
                    break;

                // Desfire Authenticate
                case "DS_Security_Authenticate":
                    m_vResult_Desfire_Authenticate();
                    break;

                // Desfire Get Application IDS
                case "DS_PICC_GetApplicationIDS":
                    m_vResult_Desfire_GetApplicationIDS();
                    break;

                // Desfire Delete Application
                case "DS_PICC_DeleteApplication":
                    m_vResult_Desfire_DeleteApplication();
                    break;

                // Desfire Create Application
                case "DS_PICC_CreateApplication":
                    m_vResult_Desfire_CreateApplication();
                    break;

                // Desfire Free Memory
                case "DS_PICC_FreeMemory":
                    m_vResult_Desfire_FreeMemory();
                    break;

                // Desfire Format PICC
                case "DS_PICC_FormatPICC":
                    m_vResult_Desfire_FormatPICC();
                    break;

                // Desfire Change Key Settings
                case "DS_Security_ChangeKeySettings":
                    m_vResult_Desfire_ChangeKeySettings();
                    break;

                // Desfire Change Key
                case "DS_Security_ChangeKey":
                    m_vResult_Desfire_ChangeKey();
                    break;

                // Desfire Get File IDs
                case "DS_APP_GetFileIDS":
                    m_vResult_Desfire_GetFileIDs();
                    break;

                // Desfire Create Standard Data File
                case "DS_APP_CreateStdDataFile":
                    m_vResult_Desfire_CreateStdDataFile();
                    break;

                // Desfire Delete File
                case "DS_APP_DeleteFile":
                    m_vResult_Desfire_DeleteFile();
                    break;

                // Desfire Create Backup Data File
                case "DS_APP_CreateBackupDataFile":
                    m_vResult_Desfire_CreateBackupDataFile();
                    break;

                // Desfire Create Value File
                case "DS_APP_CreateValueFile":
                    m_vResult_Desfire_CreateValueFile();
                    break;

                // Desfire Create Linear Record File
                case "DS_APP_CreateLinearRecordFile":
                    m_vResult_Desfire_CreateLimearRecordFile();
                    break;

                // Desfire Create Cyclic Record File
                case "DS_APP_CreateCyclicRecordFile":
                    m_vResult_Desfire_CreateCyclicRecordFile();
                    break;

                // Desfire Get File Setting
                case "DS_APP_GetFileSettings":
                    m_vResult_Desfire_GetFileSetting();
                    break;

                // Desfire Change File Setting
                case "DS_APP_ChangeFileSettings":
                    m_vResult_Desfire_ChangeFileSetting();
                    break;

                // Desfire Commit Transaction
                case "DS_Data_Commit_Transation":
                    m_vResult_Desfire_CommitTransaction();
                    break;

                // Desfire Abort Transaction
                case "DS_Data_AbortTransaction":
                    m_vResult_Desfire_AbortTransaction();
                    break;

                // Desfire Get Value
                case "DS_Data_GetValue":
                    m_vResult_Desfire_GetValue();
                    break;

                // Desfire Credit
                case "DS_Data_Credit":
                    m_vResult_Desfire_Credit();
                    break;

                // Desfire Debit
                case "DS_Data_Debit":
                    m_vResult_Desfire_Debit();
                    break;

                // Desfire Limited Credit
                case "DS_Data_LimitedCredit":
                    m_vResult_Desfire_LimitedCredit();
                    break;

                // Desfire Read Records
                case "DS_Data_ReadRecords":
                    m_vResult_Desfire_ReadRecords();
                    break;

                // Desfire Write Records
                case "DS_Data_WriteRecord":
                    m_vResult_Desfire_WriteRecords();
                    break;

                // Desfire Clear Record File
                case "DS_Data_ClearRecordFile":
                    m_vResult_Desfire_ClearRecordFile();
                    break;

                // Desfire Write Data
                case "DS_Data_WriteData":
                    m_vResult_Desfire_WriteData();
                    break;

                // Desfire Read Data
                case "DS_Data_ReadData":
                    m_vResult_Desfire_ReadData();
                    break;

                // Topaz Get UID
                case "Topaz_GetUID":
                    m_vResult_Topaz_GetUID();
                    break;

                // Topaz Read Block
                case "Topaz_ReadData":
                    m_vResult_Topaz_ReadBlock();
                    break;

                // Topaz Write Block
                case "Topaz_WriteData":
                    m_vResult_Topaz_WriteBlock();
                    break;

                // PayWave GetUID
                case "PayWave_GetUID":
                    m_vResult_PayWave_GetUID();
                    break;

                default:
                    break;
            }
        }

        // Show ISO14443B Command Result
        private void Show_ISO14443B_Result()
        {
            try
            {
                // Show Command Form
                switch (trvISO14443B.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        m_vResult_ISO14443B_GetUID();
                        break;

                    // ATTRIB
                    case "Standard_ATTRIB":
                        m_vResult_ISO14443B_ATTRIB();
                        break;

                    // APDU 
                    case "Standard_APDU":
                        m_vResult_ISO14443B_APDU();
                        break;

                    // Deselect
                    case "Standard_Deselect":
                        m_vResult_ISO14443B_Deselect();
                        break;

                    // Cepas Get UID
                    case "Cepas_GetUID":
                        m_vResult_ISO14443B_Cepas_GetUID();
                        break;

                    // SRI Get UID
                    case "SRI_GetUID":
                        m_vResult_ISO14443B_SRI_GetUID();
                        break;

                    // SRI Read
                    case "SRI_Read":
                        m_vResult_ISO14443B_SRI_Read();
                        break;

                    // SRI Write
                    case "SRI_Write":
                        m_vResult_ISO14443B_SRI_Write();
                        break;

                    // PayWave Get UID
                    case "PayWave_GetUID":
                        m_vResult_ISO14443B_PayWave_GetUID();
                        break;

                    default:
                        break;
                }
            }
            catch { }
        }

        // Show ISO15693 Command Result
        private void Show_ISO15639_Result()
        {
            try
            {
                //
                switch (trvISO15693.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        m_vResult_ISO15693_GetUID();
                        break;

                    // Read Block
                    case "Standard_Read":
                        m_vResult_ISO15693_Read();
                        break;

                    // Wirte Block
                    case "Standard_Write":
                        m_vResult_ISO15693_Write();
                        break;
                }

            }
            catch { return; }
        }

        // Show PicoTag Command Result
        private void Show_PicoTag_Result()
        {
            try
            {

                // Show Command Form
                switch (trvPicoTag.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        m_vResult_PicoTag_GetUID();
                        break;

                    // Read Block
                    case "Standard_Read":
                        m_vResult_PicoTag_Read();
                        break;

                    default:
                        break;
                }
            }
            catch { return; }
        }

        // Show Felica Command Result
        private void Show_Felica_Result()
        {
            try
            {
                //
                switch (trvFelica.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        m_vResult_Felica_GetUID();
                        break;


                }

            }
            catch { return; }
        }

        // Show P2P Command Result
        private void Show_P2P_Result()
        {
            try
            {
                // Show Command Form
                switch (trvP2P.SelectedNode.Name)
                {
                    // Send Data
                    case "Standard_SendData":
                        m_vResult_P2P_SendData();
                        break;

                    default:
                        break;
                }
            }
            catch { return; }
        }

        public frmMain()
        {
            InitializeComponent();

            labStatus.Text = "Port Closed";

            g_objSDK = new cls_MP_SDK(spMain);

            g_objSDK.DataReceive += new EventHandler(UART_RX);
            g_objSDK.DataSent += new EventHandler(UART_TX);

            g_objSDK.RecordCommunicationLog = true;

            m_bSettingProtocol = true;
        }

        // Result PayWave Get UID
        private void m_vResult_ISO14443B_PayWave_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443_PayWave_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < 8; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result PayWave Get UID
        private void m_vResult_PayWave_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objPayWave_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < 8; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result Topaz Write
        private void m_vResult_Topaz_WriteBlock()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objTopaz_WriteBlock.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Topaz Read Block
        private void m_vResult_Topaz_ReadBlock()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objTopaz_ReadBlock.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result Topaz Get UID
        private void m_vResult_Topaz_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objTopaz_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result P2P Send Data
        private void m_vResult_P2P_SendData()
        {
            Byte[] byData;
           

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objP2P_SendData.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }


            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;


            }
        }

        // Result Desfire Read Data
        private void m_vResult_Desfire_ReadData()
        {
            Byte[] byData;
            Int32 i32Size = 0;
            Int32 i32Records;
            String strData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_ReadData.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            i32Size = byData[1];
            i32Size <<= 8;
            i32Size += byData[2];
            i32Size -= 3;

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                i32Records = m_objDesfire_ReadRecords.GetRecords();

                strData = "";

                for (Int32 i32Lp = 0; i32Lp < i32Size; i32Lp++)
                    strData += byData[6 + i32Lp].ToString("X2");
                    

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
                
            }
        }

        // Result Desfire Write Data
        private void m_vResult_Desfire_WriteData()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_WriteData.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Clear Record File
        private void m_vResult_Desfire_ClearRecordFile()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_ClearRecordFile.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Write Records
        private void m_vResult_Desfire_WriteRecords()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_WriteRecords.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Read Records
        private void m_vResult_Desfire_ReadRecords()
        {
            Byte[] byData;
            Int32 i32Size = 0;
            Int32 i32Records;
            String strData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_ReadRecords.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            i32Size = byData[1];
            i32Size <<= 8;
            i32Size += byData[2];
            i32Size -= 3;

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                i32Records = m_objDesfire_ReadRecords.GetRecords();

                i32Size /= i32Records;

                for (Int32 i32Lp = 0; i32Lp < i32Records; i32Lp++)
                {
                    strData = "";

                    for (Int32 i32Inx = 0; i32Inx < i32Size; i32Inx++)
                    {
                        strData += byData[6 + i32Lp * i32Size + i32Inx].ToString("X2");
                    }

                    txtResponse.Text += "Record "+i32Lp.ToString()+":"+strData + Environment.NewLine;
                }
            }
        }

        // Result Desfire Limited Credit
        private void m_vResult_Desfire_LimitedCredit()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_LimitedCredit.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Debit
        private void m_vResult_Desfire_Debit()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_Debit.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Credit
        private void m_vResult_Desfire_Credit()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_Credit.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Get Value
        private void m_vResult_Desfire_GetValue()
        {
            Byte[] byData;
            UInt32 i32Value = 0;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_GetValue.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                i32Value += byData[9];
                i32Value <<= 8;
                i32Value += byData[8];
                i32Value <<= 8;
                i32Value += byData[7];
                i32Value <<= 8;
                i32Value += byData[6];

                txtResponse.Text += "Value:" +i32Value.ToString()+ Environment.NewLine;
            }
        }

        // Result Desfire Abort Transaction
        private void m_vResult_Desfire_AbortTransaction()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_AbortTransaction.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Commit Transaction
        private void m_vResult_Desfire_CommitTransaction()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_CommitTransaction.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Change File Setting
        private void m_vResult_Desfire_ChangeFileSetting()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_ChangeFileSetting.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Get File Setting
        private void m_vResult_Desfire_GetFileSetting()
        {
            Byte[] byData;
            Int32 ReadAccess,WriteAccess,ReadWriteAccess,ChangeAccess;
            Int32 FileSize = 0;
            Int32 LowerLimit,UpperLimit,LimitValue;
            Int32 RecordSize, MaxRecords, CurrentRecord;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_GetFileSetting.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                switch (byData[6])
                { 
                    case 0x00:
                        txtResponse.Text += "File Type:Standard Data File" +Environment.NewLine;
                        break;

                    case 0x01:
                        txtResponse.Text += "File Type:Backup Data File" + Environment.NewLine;
                        break;

                    case 0x02:
                        txtResponse.Text += "File Type:Value File" + Environment.NewLine;
                        break;

                    case 0x03:
                        txtResponse.Text += "File Type:Linear Record File" + Environment.NewLine;
                        break;

                    case 0x04:
                        txtResponse.Text += "File Type:Cyclic Record File" + Environment.NewLine;
                        break;
                }

                WriteAccess = byData[8] & 0x0F;
                ReadAccess = (byData[8] & 0xF0)>>4;
                txtResponse.Text += "Read Access:" + ReadAccess.ToString() + Environment.NewLine;
                txtResponse.Text += "Write Access:" + WriteAccess.ToString() + Environment.NewLine;

                ChangeAccess = byData[7] & 0x0F;
                ReadWriteAccess = (byData[7] & 0xF0) >> 4;
                txtResponse.Text += "Read/Write Access:" + ReadWriteAccess.ToString() + Environment.NewLine;
                txtResponse.Text += "Change Access:" + ChangeAccess.ToString() + Environment.NewLine;

                switch (byData[6])
                { 
                    case 0x00:
                    case 0x01:
                        FileSize += byData[11];
                        FileSize <<= 8;
                        FileSize += byData[10];
                        FileSize <<= 8;
                        FileSize += byData[9];
                        txtResponse.Text += "File Size:"+FileSize.ToString() + Environment.NewLine;
                        break;

                    case 0x02:
                        LowerLimit = 0;
                        LowerLimit += byData[12];
                        LowerLimit <<= 8;
                        LowerLimit += byData[11];
                        LowerLimit <<= 8;
                        LowerLimit += byData[10];
                        LowerLimit <<= 8;
                        LowerLimit += byData[9];
                        
                        txtResponse.Text += "Lower Limit:"+LowerLimit.ToString() + Environment.NewLine;

                        UpperLimit = 0;
                        UpperLimit += byData[16];
                        UpperLimit <<= 8;
                        UpperLimit += byData[15];
                        UpperLimit <<= 8;
                        UpperLimit += byData[14];
                        UpperLimit <<= 8;
                        UpperLimit += byData[13];

                        txtResponse.Text += "Upper Limit:" + UpperLimit.ToString() + Environment.NewLine;

                        LimitValue = 0;
                        LimitValue += byData[20];
                        LimitValue <<= 8;
                        LimitValue += byData[19];
                        LimitValue <<= 8;
                        LimitValue += byData[18];
                        LimitValue <<= 8;
                        LimitValue += byData[17];

                        txtResponse.Text += "Value:" + LimitValue.ToString() + Environment.NewLine;

                        txtResponse.Text += "Limited Credit:" + ((byData[21]>0x00)?"Enable":"Disable") + Environment.NewLine;
                        break;

                    case 0x03:
                    case 0x04:

                        RecordSize = 0;
                        RecordSize += byData[11];
                        RecordSize <<= 8;
                        RecordSize += byData[10];
                        RecordSize <<= 8;
                        RecordSize += byData[9];
                        txtResponse.Text += "Record Size:"+RecordSize.ToString() + Environment.NewLine;

                        MaxRecords = 0;
                        MaxRecords += byData[14];
                        MaxRecords <<= 8;
                        MaxRecords += byData[13];
                        MaxRecords <<= 8;
                        MaxRecords += byData[12];
                        txtResponse.Text += "Max Records:" + MaxRecords.ToString() + Environment.NewLine;

                        CurrentRecord = 0;
                        CurrentRecord += byData[17];
                        CurrentRecord <<= 8;
                        CurrentRecord += byData[16];
                        CurrentRecord <<= 8;
                        CurrentRecord += byData[15];
                        txtResponse.Text += "Current Record:" + CurrentRecord.ToString() + Environment.NewLine;
                        break;
                }
                
            }
        }

        // Result Desfire Create Cyclic Record File
        private void m_vResult_Desfire_CreateCyclicRecordFile()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_CreateCyclicRecordFile.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Create Linear Record File
        private void m_vResult_Desfire_CreateLimearRecordFile()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_CreateLinearRecordFile.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Create Value File
        private void m_vResult_Desfire_CreateValueFile()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_CreateValueFile.txtResponse;
            
            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Create Backup Data File
        private void m_vResult_Desfire_CreateBackupDataFile()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_CreateBackupDataFile.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Delete File
        private void m_vResult_Desfire_DeleteFile()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_DeleteFile.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Create Standard Data File
        private void m_vResult_Desfire_CreateStdDataFile()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_CreateStdDataFile.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Get File IDS
        private void m_vResult_Desfire_GetFileIDs()
        {
            Byte[] byData;
            Int32 i32Inx = 6;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_GetFileIDs.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
                txtResponse.Text += "File IDs:" + Environment.NewLine;

                while (byData.Length-1 - i32Inx >= 1)
                {
                    txtResponse.Text += byData[i32Inx].ToString() + Environment.NewLine;
                    i32Inx += 1;
                }
            }
        }

        // Result Desfire Change Key
        private void m_vResult_Desfire_ChangeKey()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_ChangeKey.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Change Key Settings
        private void m_vResult_Desfire_ChangeKeySettings()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_ChangeKeySettings.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Format PICC
        private void m_vResult_Desfire_FormatPICC()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_FormatPICC.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Free Memory
        private void m_vResult_Desfire_FreeMemory()
        {
            Byte[] byData;
            Int32 i32Size = 0;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_FreeMemory.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                i32Size = byData[8];
                i32Size <<= 8;
                i32Size += byData[7];
                i32Size <<= 8;
                i32Size += byData[6];

                txtResponse.Text += "Size:" +i32Size.ToString()+" Bytes" +Environment.NewLine;
            }
        }

        // Result Desfire Create Application
        private void m_vResult_Desfire_CreateApplication()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_CreateApplication.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Delete Application
        private void m_vResult_Desfire_DeleteApplication()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_DeleteApplication.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }
        
        // Result Desfire Get Application IDS
        private void m_vResult_Desfire_GetApplicationIDS()
        {
            Byte[] byData;
            Int32 i32Inx = 6;
          
            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_GetApplicationIDS.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
                txtResponse.Text += "AIDs:" + Environment.NewLine;

                while (byData.Length - i32Inx >= 3)
                {
                    txtResponse.Text += byData[i32Inx].ToString("X2") + byData[i32Inx+1].ToString("X2")+byData[i32Inx+2].ToString("X2")+Environment.NewLine;
                    i32Inx += 3;
                }
            }
        }

        // Result Desfire Authenticate
        private void m_vResult_Desfire_Authenticate()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_Authenticate.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result Desfire Get Key Setting
        private void m_vResult_Desfire_GetKeySetting()
        {
            Byte[] byData;
            String[] strAuth = {"(3)DES","3K3DES","AES"};

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_GetKeySetting.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
                txtResponse.Text += "Max Number Of Keys:" + (byData[7]&0x0F).ToString("") + Environment.NewLine;
                txtResponse.Text += "Authenicate:" + strAuth[(Int32)((byData[7]>>6)&0x03)] + Environment.NewLine;
                txtResponse.Text += "ChangeKey Access:" + ((byData[6] >> 4) & 0x0F).ToString() + Environment.NewLine;
                txtResponse.Text += Environment.NewLine;
                txtResponse.Text += "Configration Changable:" + (((byData[6] & 0x08) > 0) ? "Yes" : "No")  +Environment.NewLine;
                txtResponse.Text += Environment.NewLine;
                txtResponse.Text += "Free Create/Delete Without Master Key:" + (((byData[6] & 0x04) > 0) ? "Yes" : "No") + Environment.NewLine;
                txtResponse.Text += Environment.NewLine;
                txtResponse.Text += "Free Direct List Access Without Master Key:" + (((byData[6] & 0x02) > 0) ? "Yes" : "No") + Environment.NewLine;
                txtResponse.Text += Environment.NewLine;
                txtResponse.Text += "Allow Change Master Key:" + (((byData[6] & 0x04) > 0) ? "Yes" : "No") + Environment.NewLine;
            }
        }

        // Result Desfire Get Key Version
        private void m_vResult_Desfire_GetKeyVersion()
        {
            Byte[] byData;
            
            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_GetKeyVersion.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if(byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
                txtResponse.Text += "Key Version:" + byData[6].ToString("X2") + Environment.NewLine;
            }
        }

        // Result Desfire Get Version
        private void m_vResult_Desfire_GetVersion()
        {
            Byte[] byData;
            
            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_GetVersion.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if(byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
                txtResponse.Text += "Memory Size:" + Math.Pow(2, (byData[5 + 6]) / 2).ToString() + Environment.NewLine;
                txtResponse.Text += "Hardware Version:" + byData[5 + 4].ToString() + "." + byData[5 + 5].ToString() + Environment.NewLine;
                txtResponse.Text += "Software Version:" + byData[5 + 11].ToString() + "." + byData[5 + 12].ToString() + Environment.NewLine;

                if(byData[5+28] > 0x09)
                    txtResponse.Text += "Manufacture Year:" +"20" + byData[5 + 28].ToString("X00") + Environment.NewLine;
                else
                    txtResponse.Text += "Manufacture Year:" + "20" + byData[5 + 28].ToString("00") + Environment.NewLine;

            }
        }

        // Result Desfire Select Application
        private void m_vResult_Desfire_SelectApplication()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objDesfire_SelectApplication.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");

                if (byData[5] == 0xDF)
                    txtResponse.Text += Environment.NewLine + "Desfire Error:" + byData[6].ToString("X2") + GetDesfireErrorName(byData[6]);

                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Desfire Error Name
        private String GetDesfireErrorName(Byte byErrorCode)
        {
            String strErrName = "";

            switch (byErrorCode)
            {
                case 0x0C:
                    strErrName = "NO_CHANGES";
                    break;

                case 0x0E:
                    strErrName = "OUT_OF_EEPROM_ERROR";
                    break;

                case 0x1C:
                    strErrName = "ILLEGAL_COMMAND_CODE";
                    break;

                case 0x1E:
                    strErrName = "INTEGRITY_ERROR";
                    break;

                case 0x40:
                    strErrName = "NO_SUCH_KEY";
                    break;

                case 0x7E:
                    strErrName = "LENGTH_ERROR";
                    break;

                case 0x9D:
                    strErrName = "PERMISSION_DENIED";
                    break;

                case 0x9E:
                    strErrName = "PARAMETER_ERROR";
                    break;

                case 0xA0:
                    strErrName = "APPLICATION_NOT_FOUND";
                    break;

                case 0xA1:
                    strErrName = "APPL_INTEGRITY_ERROR";
                    break;

                case 0xAE:
                    strErrName = "AUTHENTICATION_ERROR";
                    break;

                case 0xAF:
                    strErrName = "ADDITIONAL_FRAME";
                    break;

                case 0xBE:
                    strErrName = "BOUNDARY_ERROR";
                    break;

                case 0xC1:
                    strErrName = "BOUNDARY_ERROR";
                    break;

                case 0xCA:
                    strErrName = "COMMAND_ABORTED";
                    break;

                case 0xCD:
                    strErrName = "PICC_DISABLED_ERROR";
                    break;

                case 0xCE:
                    strErrName = "COUNT_ERROR";
                    break;

                case 0xDE:
                    strErrName = "DUPLICATE_ERROR";
                    break;

                case 0xEE:
                    strErrName = "EEPROM_ERROR";
                    break;

                case 0xF0:
                    strErrName = "FILE_NOT_FOUND";
                    break;

                case 0xF1:
                    strErrName = "FILE_INTEGRITY_ERROR";
                    break;

                default:
                    strErrName = "None";
                    break;
            }
            return "("+strErrName+")";
        }

        // Reader Error Name
        private String GetReaderErrorName(Byte byErrorCode)
        {
            String strErrName = "";

            switch (byErrorCode)
            {
                case 0xA0:
                    strErrName = "HALT error";
                    break;

                case 0xA1:
                    strErrName = "MIFARE Authentication Error";
                    break;

                case 0xA2:
                    strErrName = "MIFARE Access Error";
                    break;

                case 0xA3:
                    strErrName = "MIFARE Response Error";
                    break;

                case 0xB0:
                    strErrName = "ISO14443B Error";
                    break;

                case 0xD0:
                    strErrName = "ISO15693 Error";
                    break;

                case 0xE0:
                    strErrName = "No Response";
                    break;

                case 0xE1:
                    strErrName = "Frame Error";
                    break;

                case 0xE2:
                    strErrName = "Collision Error";
                    break;

                case 0xE3:
                    strErrName = "Parity Error";
                    break;

                case 0xE4:
                    strErrName = "CRC Error";
                    break;

                case 0xE5:
                    strErrName = "Invalid Response";
                    break;

                case 0xCE:
                    strErrName = "PayWave Error";
                    break;
                default:
                    strErrName = "None";
                    break;
            }
            return "(" + strErrName + ")";
        }

        // Result ISO7816 Get ATR
        private void m_vResult_ISO7816_GetATR()
        {
            Byte[] byData;
            String strATR = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO7816_GetATS.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strATR += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "ATR:" + strATR + Environment.NewLine;
            }
        }

        // Result ISO7816 APDU
        private void m_vResult_ISO7816_APDU()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO7816_APDU.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result ISO7816 Special HealthIC Taiwan
        private void m_vResult_ISO7816_Special_HealthIC_Taiwan()
        {
            Byte[] byData;
            String strName = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO7816_Special_TaiwanHealthIC.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                txtResponse.Text += "Card ID:" + System.Text.Encoding.Default.GetString(byData,6,12) + Environment.NewLine;

                txtResponse.Text += "Personal ID:" + System.Text.Encoding.Default.GetString(byData, 6+32, 10) + Environment.NewLine;

                txtResponse.Text += "Birthday:" + System.Text.Encoding.Default.GetString(byData, 6 + 42, 3) + "/"
                    + System.Text.Encoding.Default.GetString(byData, 6 + 45, 2) +"/"
                    + System.Text.Encoding.Default.GetString(byData, 6 + 47, 2)
                    + Environment.NewLine;

                //((System.Text.Encoding.Default.GetString(byData, 6 + 49, 1) == "M") ? "Male" : "Female")
                txtResponse.Text += "Sex:" + ((System.Text.Encoding.Default.GetString(byData, 6 + 49, 1) == "M") ? "Male" : "Female")
                                + Environment.NewLine;

                Int32 i32Inx = 12+6;
                while (true)
                {
                    if (byData[i32Inx] == 0x00 && byData[i32Inx + 1] == 0x00) break;

                    strName += Encoding.GetEncoding(950).GetString(byData, i32Inx, 2);

                    i32Inx += 2;
                }
                txtResponse.Text += "Name:" + strName; 

            }
        }

        // Result ISO14443B Get UID
        private void m_vResult_ISO14443B_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443B_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result ISO14443B ATTRIB
        private void m_vResult_ISO14443B_ATTRIB()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443B_ATTRIB.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

            }
        }

        // Result ISO14443B APDU
        private void m_vResult_ISO14443B_APDU()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443B_APDU.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }


            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result ISO14443B Deselect
        private void m_vResult_ISO14443B_Deselect()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // 
            txtResponse = m_objISO14443B_Deselect.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

            }
        }

        // Result ISO14443B Cepas Get UID
        private void m_vResult_ISO14443B_Cepas_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443B_Cepas_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result ISO14443B SRI Get UID
        private void m_vResult_ISO14443B_SRI_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443B_SRI_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result ISO14443B SRI Read
        private void m_vResult_ISO14443B_SRI_Read()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443_SRI_ReadBlock.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result ISO14443B SRI Write
        private void m_vResult_ISO14443B_SRI_Write()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443_SRI_WriteBlock.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result PicoTag Get UID
        private void m_vResult_PicoTag_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objPicoTag_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result PicoTag Read
        private void m_vResult_PicoTag_Read()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objPicotag_Read.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result Felica Get UID
        private void m_vResult_Felica_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objFelica_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result ISO15693 Get UID
        private void m_vResult_ISO15693_GetUID()
        {
            Byte[] byData;
            String strUID = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO15693_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result ISO15693 Read
        private void m_vResult_ISO15693_Read()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO15693_ReadBlock.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result ISO15693 Write
        private void m_vResult_ISO15693_Write()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO15693_WriteBlock.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result ISO14443A Get UID
        private void m_vResult_ISO14443A_GetUID()
        {
            Byte[] byData;
            String strUID = "";
     
            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_GetUID.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2]-3; i32Lp++)
                    strUID += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "UID:" + strUID + Environment.NewLine;
            }
        }

        // Result ISO14443A RATS
        private void m_vResult_ISO14443A_RATS()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_RATS.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

            }
        }

        // Result ISO14443A APDU
        private void m_vResult_ISO14443A_APDU()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_APDU.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }


            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result ISO14443A Deselect
        private void m_vResult_ISO14443A_Deselect()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // 
            txtResponse = m_objISO14443A_Deselect.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

            }
        }

        // Result ISO14443A Read Mifare
        private void m_vResult_ISO14443A_ReadMifare()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_ReadMifare.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result ISO14443A Write Mifare
        private void m_vResult_ISO14443A_WriteMifare()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_WriteMifare.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result ISO14443A Ultralight Read Page 
        private void m_vResult_ISO14443A_Ultralight_ReadPage()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_Ultralight_Read.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result ISO14443A Ultralight Write Page
        private void m_vResult_ISO14443A_Ultralight_WritePage()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_Ultralight_Write.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result ISO14443A Ultralight C Authenticate
        private void m_vResult_ISO14443A_UltralightC_Auth()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_UltralightC_Auth.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Result ISO14443A Ultralight C Read Page 
        private void m_vResult_ISO14443A_UltralightC_ReadPage()
        {
            Byte[] byData;
            String strData = "";

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_UltralightC_Read.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;

                for (Int32 i32Lp = 0; i32Lp < byData[2] - 3; i32Lp++)
                    strData += byData[i32Lp + 6].ToString("X2");

                txtResponse.Text += "Data:" + strData + Environment.NewLine;
            }
        }

        // Result ISO14443A Ultralight C Write Page
        private void m_vResult_ISO14443A_UltralightC_WritePage()
        {
            Byte[] byData;

            System.Windows.Forms.TextBox txtResponse;

            byData = g_objSDK.RxData;

            // Request
            txtResponse = m_objISO14443A_UltralightC_Write.txtResponse;

            txtResponse.Text = "";

            if (byData.Length <= 0) { txtResponse.Text = ""; return; }

            if (byData[5] == 0xE0)
            {
                txtResponse.Text = "No Response";
                return;
            }

            if (byData[5] != 0x01)
            {
                txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                return;
            }

            if (byData[5] == 0x01)
            {
                txtResponse.Text = "";

                txtResponse.Text += "Response OK" + Environment.NewLine;
            }
        }

        // Open Port Event
        private void m_vOpenPort(object sender, EventArgs e)
        {
            ToolStripMenuItem objItem = (ToolStripMenuItem)sender;

            if (spMain.IsOpen == true) spMain.Close();

            try
            {
                spMain.PortName = objItem.Text;
                spMain.Open();

                labStatus.Text = "Port:" + spMain.PortName + " ,Baudrate:" + spMain.BaudRate.ToString() + " ,Parity:" + spMain.Parity.ToString() + " ,Data bit:" + spMain.DataBits.ToString() + " ,Stop bit:" + spMain.StopBits.ToString();

                mnu_Port_Config.Enabled = false;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        // When Click Ports Then Get System Ports
        private void mnuPorts_Click(object sender, EventArgs e)
        {
            String[] strPortNames = System.IO.Ports.SerialPort.GetPortNames();

            mnuOpenPort.DropDownItems.Clear();

            mnuOpenPort.Text = "Open(" + strPortNames.Count().ToString() + ")";

            for (Int32 i32Lp = 0; i32Lp < strPortNames.Count(); i32Lp++)
            {
                mnuOpenPort.DropDownItems.Add(strPortNames[i32Lp]);
                mnuOpenPort.DropDownItems[mnuOpenPort.DropDownItems.Count - 1].Click += new System.EventHandler(m_vOpenPort); ;
            }
        }

        // Close Port
        private void mnuClosePort_Click(object sender, EventArgs e)
        {
            labStatus.Text = "";

            for (Int32 i32Lp = 0; i32Lp < tabMain.TabCount; i32Lp++)
                if (tabMain.TabPages[i32Lp].Text != "ISO7816")
                    tabMain.TabPages[i32Lp].ImageIndex = 0;

            if (spMain.IsOpen == true) spMain.Close();

            mnu_Port_Config.Enabled = true;

            labStatus.Text = "Port Closed";
        }

        // Show About
        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmAbout objForm = new frmAbout();

            objForm.ShowDialog();
        }

        // Select Protocol By ISO14443A
        private void btnISO14443A_SetProtocol_Click(object sender, EventArgs e)
        {
            for (Int32 i32Lp = 0; i32Lp < tabMain.TabCount; i32Lp++)
                if(tabMain.TabPages[i32Lp].Text != "ISO7816")
                    tabMain.TabPages[i32Lp].ImageIndex = 0;

            m_bSettingProtocol = true;

            g_objSDK.General_SelectProtocol(cls_MP_SDK.CommunicationProtocol.ISO14443A);

            try
            {
                if (g_objSDK.RxData[5] == 0x01) tabMain.TabPages[0].ImageIndex = 1;
            }
            catch { }
        }

        // Send ISO14443A Commmand
        private void btnISO14443A_Command_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = false;

            trvISO14443A.Focus();
            try
            {
                //
                switch (trvISO14443A.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        g_objSDK.ISO14443A_GetUID();
                        m_vResult_ISO14443A_GetUID();
                        break;

                    // RATS
                    case "Standard_RATS":
                        g_objSDK.ISO14443A_RATS();
                        m_vResult_ISO14443A_RATS();
                        break;

                    // APDU
                    case "Standard_APDU":
                        g_objSDK.ISO14443A_APDU(m_objISO14443A_APDU.GetCommand());
                        m_vResult_ISO14443A_APDU();
                        break;

                    // Deselect
                    case "Standard_Deselect":
                        g_objSDK.ISO14443A_Deselect();
                        m_vResult_ISO14443A_Deselect();
                        break;

                    // Read Mifare
                    case "Mifare_Read":
                        g_objSDK.ISO14443A_Mifare_Read(m_objISO14443A_ReadMifare.GetBlock(), (cls_MP_SDK.MiafreKeyType)m_objISO14443A_ReadMifare.GetKeyType(), m_objISO14443A_ReadMifare.GetKey());
                        m_vResult_ISO14443A_ReadMifare();
                        break;

                    // Write Mifare
                    case "Mifare_Write":
                        g_objSDK.ISO14443A_Mifare_Write(m_objISO14443A_WriteMifare.GetBlock(), (cls_MP_SDK.MiafreKeyType)m_objISO14443A_WriteMifare.GetKeyType(), m_objISO14443A_WriteMifare.GetKey(), m_objISO14443A_WriteMifare.GetData());
                        m_vResult_ISO14443A_WriteMifare();
                        break;

                    // Ultralight Read
                    case "Ultralight_Read":
                        g_objSDK.ISO14443A_Ultralight_ReadPage(m_objISO14443A_Ultralight_Read.GetPage());
                        m_vResult_ISO14443A_Ultralight_ReadPage();
                        break;

                    // Ultralight Write
                    case "Ultralight_Write":
                        g_objSDK.ISO14443A_Ultralight_WritePage(m_objISO14443A_Ultralight_Write.GetPage(), m_objISO14443A_Ultralight_Write.GetData());
                        m_vResult_ISO14443A_Ultralight_WritePage();
                        break;
                        
                      // Ultralight C Authenticate
                    case "UltralightC_Auth":
                        g_objSDK.ISO14443A_UltralightC_Authenticate(m_objISO14443A_UltralightC_Auth.GetKey());
                        m_vResult_ISO14443A_UltralightC_Auth();
                        break;

                    // Ultralight C Read
                    case "UltralightC_Read":
                        g_objSDK.ISO14443A_UltralightC_ReadPage(m_objISO14443A_UltralightC_Read.GetPage());
                        m_vResult_ISO14443A_UltralightC_ReadPage();
                        break;

                    // Ultralight Write
                    case "UltralightC_Write":
                        g_objSDK.ISO14443A_UltralightC_WritePage(m_objISO14443A_UltralightC_Write.GetPage(), m_objISO14443A_UltralightC_Write.GetData());
                        m_vResult_ISO14443A_UltralightC_WritePage();
                        break;

                    // Desfire Get Version
                    case "DS_PICC_GetVersion":
                        g_objSDK.Desfire_GetVersion();
                        m_vResult_Desfire_GetVersion();
                        break;

                    // Desfire Select Application
                    case "DS_PICC_SelectApplication":
                        g_objSDK.Desfire_SelectApplication(m_objDesfire_SelectApplication.GetAID());
                        m_vResult_Desfire_SelectApplication();
                        break;

                    // Desfire Get Key Version
                    case "DS_Security_GetKeyVersion":
                        g_objSDK.Desfire_GetKeyVersion(m_objDesfire_GetKeyVersion.GetKeyNumber());
                        m_vResult_Desfire_GetKeyVersion();
                        break;

                    // Desfire Get Key Setting
                    case "DS_PICC_GetKeySettings":
                        g_objSDK.Desfire_GetKeySetting();
                        m_vResult_Desfire_GetKeySetting();
                        break;

                    // Desfire Authenticate
                    case "DS_Security_Authenticate":
                        g_objSDK.Desfire_Authenticate(m_objDesfire_Authenticate.GetKey(), (cls_MP_SDK.DesfireAuthType)m_objDesfire_Authenticate.GetCryptoType(), m_objDesfire_Authenticate.GetKeyNo());
                        m_vResult_Desfire_Authenticate();
                        break;    

                    // Desfire Get Application IDS
                    case "DS_PICC_GetApplicationIDS":
                        g_objSDK.Desfire_GetApplicationIDS();
                        m_vResult_Desfire_GetApplicationIDS();
                        break;

                    // Desfire Delete Application
                    case "DS_PICC_DeleteApplication":
                        g_objSDK.Desfire_DeleteApplication(m_objDesfire_DeleteApplication.GetAID());
                        m_vResult_Desfire_DeleteApplication();
                        break;

                    // Desfire Create Application
                    case "DS_PICC_CreateApplication":
                        g_objSDK.Desfire_CreateApplication(m_objDesfire_CreateApplication.GetAID(),
                            m_objDesfire_CreateApplication.GetMaxKeys(),
                            (cls_MP_SDK.DesfireAuthType)m_objDesfire_CreateApplication.GetCryptoType(),
                            m_objDesfire_CreateApplication.GetChangeKeyAccess(),
                            (cls_MP_SDK.Condition)m_objDesfire_CreateApplication.GetCondition1(),
                            (cls_MP_SDK.Condition)m_objDesfire_CreateApplication.GetCondition2(),
                            (cls_MP_SDK.Condition)m_objDesfire_CreateApplication.GetCondition3(),
                            (cls_MP_SDK.Condition)m_objDesfire_CreateApplication.GetCondition4());
                        m_vResult_Desfire_CreateApplication();
                        break;

                    // Desfire Free Memory
                    case "DS_PICC_FreeMemory":
                        g_objSDK.Desfire_FreeMemory();
                        m_vResult_Desfire_FreeMemory();
                        break;

                    // Desfire Format PICC
                    case "DS_PICC_FormatPICC":
                        g_objSDK.Desfire_FormatPICC();
                        m_vResult_Desfire_FormatPICC();
                        break;

                    // Desfire Change Key Settings
                    case "DS_Security_ChangeKeySettings":
                        g_objSDK.Desfire_ChangeKeySettings(m_objDesfire_ChangeKeySettings.GetChangeKeyAccess(),
                             (cls_MP_SDK.Condition)m_objDesfire_ChangeKeySettings.GetCondition1(),
                             (cls_MP_SDK.Condition)m_objDesfire_ChangeKeySettings.GetCondition2(),
                             (cls_MP_SDK.Condition)m_objDesfire_ChangeKeySettings.GetCondition3(),
                             (cls_MP_SDK.Condition)m_objDesfire_ChangeKeySettings.GetCondition4());
                        m_vResult_Desfire_ChangeKeySettings();
                        break;

                    // Desfire Change Key
                    case "DS_Security_ChangeKey":
                        g_objSDK.Desfire_ChangeKey(m_objDesfire_ChangeKey.GetKeyNo(),
                                                   m_objDesfire_ChangeKey.GetOldKey(),
                                                   m_objDesfire_ChangeKey.GetKey(), 
                                                   m_objDesfire_ChangeKey.GetKeyVersion());
                        m_vResult_Desfire_ChangeKey();
                        break;

                    // Desfire Get File IDs
                    case "DS_APP_GetFileIDS":
                        g_objSDK.Desfire_GetFileIDs();
                        m_vResult_Desfire_GetFileIDs();
                        break;

                    // Desfire Create Standard Data File
                    case "DS_APP_CreateStdDataFile":
                        g_objSDK.Desfire_CreateStdDataFile(m_objDesfire_CreateStdDataFile.GetFileNo(),
                                                           m_objDesfire_CreateStdDataFile.GetReadAccess(),
                                                           m_objDesfire_CreateStdDataFile.GetWriteAccess(),
                                                           m_objDesfire_CreateStdDataFile.GetReadWriteAccess(),
                                                           m_objDesfire_CreateStdDataFile.GetChangeAccess(),
                                                           m_objDesfire_CreateStdDataFile.GetFileSize());
                        m_vResult_Desfire_CreateStdDataFile();
                        break;

                    // Desfire Delete File
                    case "DS_APP_DeleteFile":
                        g_objSDK.Desfire_DeleteFile(m_objDesfire_DeleteFile.GetFileNo());
                        m_vResult_Desfire_DeleteFile();
                        break;

                    // Desfire Create Backup Data File
                    case "DS_APP_CreateBackupDataFile":
                        g_objSDK.Desfire_CreateBackupDataFile(m_objDesfire_CreateBackupDataFile.GetFileNo(),
                                                           m_objDesfire_CreateBackupDataFile.GetReadAccess(),
                                                           m_objDesfire_CreateBackupDataFile.GetWriteAccess(),
                                                           m_objDesfire_CreateBackupDataFile.GetReadWriteAccess(),
                                                           m_objDesfire_CreateBackupDataFile.GetChangeAccess(),
                                                           m_objDesfire_CreateBackupDataFile.GetFileSize());
                        m_vResult_Desfire_CreateBackupDataFile();
                        break;

                    // Desfire Create Value File
                    case "DS_APP_CreateValueFile":
                        g_objSDK.Desfire_CreateValueFile(m_objDesfire_CreateValueFile.GetFileNo(),
                                                         m_objDesfire_CreateValueFile.GetReadAccess(),
                                                         m_objDesfire_CreateValueFile.GetWriteAccess(),
                                                         m_objDesfire_CreateValueFile.GetReadWriteAccess(),
                                                         m_objDesfire_CreateValueFile.GetChangeAccess(),
                                                         m_objDesfire_CreateValueFile.GetLowerLimit(),
                                                         m_objDesfire_CreateValueFile.GetUpperLimit(),
                                                         m_objDesfire_CreateValueFile.GetValue(),
                                                         (cls_MP_SDK.LimitedCredit)(m_objDesfire_CreateValueFile.GetLimitCredit()==false?0:1));
                        m_vResult_Desfire_CreateValueFile();
                        break;

                    // Desfire Create Linear Record File
                    case "DS_APP_CreateLinearRecordFile":
                        g_objSDK.Desfire_CreateLinearRecordFile(m_objDesfire_CreateLinearRecordFile.GetFileNo(),
                                                                m_objDesfire_CreateLinearRecordFile.GetReadAccess(),
                                                                m_objDesfire_CreateLinearRecordFile.GetWriteAccess(),
                                                                m_objDesfire_CreateLinearRecordFile.GetReadWriteAccess(),
                                                                m_objDesfire_CreateLinearRecordFile.GetChangeAccess(),
                                                                m_objDesfire_CreateLinearRecordFile.GetRecords(),
                                                                m_objDesfire_CreateLinearRecordFile.GetMaxRecords());
                        m_vResult_Desfire_CreateLimearRecordFile();
                        break;  

                    // Desfire Create Cyclic Record File
                    case "DS_APP_CreateCyclicRecordFile":
                        g_objSDK.Desfire_CreateCyclicRecordFile(m_objDesfire_CreateCyclicRecordFile.GetFileNo(),
                                                                m_objDesfire_CreateCyclicRecordFile.GetReadAccess(),
                                                                m_objDesfire_CreateCyclicRecordFile.GetWriteAccess(),
                                                                m_objDesfire_CreateCyclicRecordFile.GetReadWriteAccess(),
                                                                m_objDesfire_CreateCyclicRecordFile.GetChangeAccess(),
                                                                m_objDesfire_CreateCyclicRecordFile.GetRecords(),
                                                                m_objDesfire_CreateCyclicRecordFile.GetMaxRecords());
                        m_vResult_Desfire_CreateCyclicRecordFile();
                        break;

                    // Desfire Get File Setting
                    case "DS_APP_GetFileSettings":
                        g_objSDK.Desfire_GetFileSetting(m_objDesfire_GetFileSetting.GetFileNo());
                        m_vResult_Desfire_GetFileSetting();
                        break;

                    // Desfire Change File Setting
                    case "DS_APP_ChangeFileSettings":
                        g_objSDK.Desfire_ChangeFileSetting(m_objDesfire_ChangeFileSetting.GetFileNo(),
                                                           m_objDesfire_ChangeFileSetting.GetReadAccess(),
                                                           m_objDesfire_ChangeFileSetting.GetWriteAccess(),
                                                           m_objDesfire_ChangeFileSetting.GetReadWriteAccess(),
                                                           m_objDesfire_ChangeFileSetting.GetChangeAccess());
                        m_vResult_Desfire_ChangeFileSetting();
                        break;

                    // Desfire Commit Transaction
                    case "DS_Data_Commit_Transation":
                        g_objSDK.Desfire_CommitTransaction();
                        m_vResult_Desfire_CommitTransaction();
                        break;

                    // Desfire Abort Transaction
                    case "DS_Data_AbortTransaction":
                        g_objSDK.Desfire_AbortTransaction();
                        m_vResult_Desfire_AbortTransaction();
                        break;

                    // Desfire Get Value
                    case "DS_Data_GetValue":
                        g_objSDK.Desfire_GetValue(m_objDesfire_GetValue.GetFileNo());
                        m_vResult_Desfire_GetValue();
                        break;

                    // Desfire Credit
                    case "DS_Data_Credit":
                        g_objSDK.Desfire_Credit(m_objDesfire_Credit.GetFileNo(), m_objDesfire_Credit.GetValue());
                        m_vResult_Desfire_Credit();
                        break;

                    // Desfire Debit
                    case "DS_Data_Debit":
                        g_objSDK.Desfire_Debit(m_objDesfire_Debit.GetFileNo(), m_objDesfire_Debit.GetValue());
                        m_vResult_Desfire_Debit();
                        break;

                    // Desfire Limited Credit
                    case "DS_Data_LimitedCredit":
                        g_objSDK.Desfire_LimitedCredit(m_objDesfire_LimitedCredit.GetFileNo(), m_objDesfire_LimitedCredit.GetValue());
                        m_vResult_Desfire_LimitedCredit();
                        break;
                    
                    // Desfire Read Records
                    case "DS_Data_ReadRecords":
                        g_objSDK.Desfire_ReadRecords(m_objDesfire_ReadRecords.GetFileNo(), m_objDesfire_ReadRecords.GetOffset(), m_objDesfire_ReadRecords.GetRecords());
                        m_vResult_Desfire_ReadRecords();
                        break;

                    // Desfire Write Records
                    case "DS_Data_WriteRecord":
                        g_objSDK.Desfire_WriteRecords(m_objDesfire_WriteRecords.GetFileNo(), m_objDesfire_WriteRecords.GetOffset(), m_objDesfire_WriteRecords.GetDataSize(), m_objDesfire_WriteRecords.GetData());
                        m_vResult_Desfire_WriteRecords();
                        break;

                    // Desfire Clear Record File
                    case "DS_Data_ClearRecordFile":
                        g_objSDK.Desfire_ClearRecordFile(m_objDesfire_ClearRecordFile.GetFileNo());
                        m_vResult_Desfire_ClearRecordFile();
                        break;

                    // Desfire Write Data
                    case "DS_Data_WriteData":
                        g_objSDK.Desfire_WriteData(m_objDesfire_WriteData.GetFileNo(), m_objDesfire_WriteData.GetOffset(), m_objDesfire_WriteData.GetDataSize(), m_objDesfire_WriteData.GetData());
                        m_vResult_Desfire_WriteData();
                        break;

                    // Desfire Read Data
                    case "DS_Data_ReadData":
                        g_objSDK.Desfire_ReadData(m_objDesfire_ReadData.GetFileNo(), m_objDesfire_ReadData.GetOffset(), m_objDesfire_ReadData.GetDataSize());
                        m_vResult_Desfire_ReadData();
                        break;

                    // Topaz Get UID
                    case "Topaz_GetUID":
                        g_objSDK.Topaz_GetUID();
                        m_vResult_Topaz_GetUID();
                        break; 

                    // Topaz Read Block
                    case "Topaz_ReadData":
                        g_objSDK.Topaz_ReadBlock(m_objTopaz_ReadBlock.GetBlock());
                        m_vResult_Topaz_ReadBlock();
                        break; 

                    // Topaz Write Block
                    case "Topaz_WriteData":
                        g_objSDK.Topaz_WriteBlock(m_objTopaz_WriteBlock.GetBlock(), m_objTopaz_WriteBlock.GetData());
                        m_vResult_Topaz_WriteBlock();
                        break; 

                    // PayWave GetUID
                    case "PayWave_GetUID":
                        g_objSDK.ISO14443A_PayWave_GetUID();
                        m_vResult_PayWave_GetUID();
                        break;

                        
                }

            }
            catch {return; }
        }

        // Clear Communication Logs
        private void btnClearLog_Click(object sender, EventArgs e)
        {
           
            txtCommunicationLogs.Text = "";
            g_objSDK.CommunicationLogs = "";
        }

        // Update Firmware
        private void mnuUpdateFirmware_Click(object sender, EventArgs e)
        {
            OpenFileDialog objFile = new OpenFileDialog();

            if (spMain.IsOpen == false) return;

            objFile.Filter = "Firmware File|*.bin";

            if (objFile.ShowDialog() != DialogResult.OK) return;

            frmUpdateFirmware objForm = new frmUpdateFirmware();

            g_objSDK.StopUartReceiveEvent();

            objForm.g_ojSDK = g_objSDK;
            objForm.spYModem = spMain;
            objForm.g_strFlilName = objFile.FileName;

            Int32 i32Baudrate = spMain.BaudRate;

            objForm.ShowDialog();

            g_objSDK.StartUartReceiveEvent();

            g_objSDK.CommunicationLogs = "";

            txtCommunicationLogs.Text = "";

            spMain.BaudRate = i32Baudrate;

        }

        // Get Firmware Version
        private void mnuGetFirmwareVersion_Click(object sender, EventArgs e)
        {
            g_objSDK.General_GetFirmwareVersion();

            Byte[] byData;
            String strVersion = "";

            byData = g_objSDK.RxData;
            if (byData == null) return;

            if (byData.Length <= 0) return; 

            if (byData[5] == 0x01)
            {
                strVersion = System.Text.Encoding.ASCII.GetString(byData, 6, byData[2] - 3);

                frmFirmwareVersion objForm = new frmFirmwareVersion();

                objForm.g_strFirmware = strVersion;

                objForm.ShowDialog();
            }
        }

        // Select ISO14443A Commmand
        private void trvISO14443A_AfterSelect(object sender, TreeViewEventArgs e)
        {
            pnlISO14443A.Controls.Clear();

            // Show Command Form
            switch (e.Node.Name)
            {
                // Get UID
                case "Standard_GetUID":
                    m_objISO14443A_GetUID.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_GetUID);
                    m_objISO14443A_GetUID.Show();
                    break;

                // RATS
                case "Standard_RATS":
                    m_objISO14443A_RATS.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_RATS);
                    m_objISO14443A_RATS.Show();
                    break;

                // APDU
                case "Standard_APDU":
                    m_objISO14443A_APDU.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_APDU);
                    m_objISO14443A_APDU.Show();
                    break;

                // Deselect
                case "Standard_Deselect":
                    m_objISO14443A_Deselect.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_Deselect);
                    m_objISO14443A_Deselect.Show();
                    break;

                // Read Mifare
                case "Mifare_Read":
                    m_objISO14443A_ReadMifare.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_ReadMifare);
                    m_objISO14443A_ReadMifare.Show();
                    break;

                // Write Mifare
                case "Mifare_Write":
                    m_objISO14443A_WriteMifare.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_WriteMifare);
                    m_objISO14443A_WriteMifare.Show();
                    break;

                // Ultralight Read
                case "Ultralight_Read":
                    m_objISO14443A_Ultralight_Read.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_Ultralight_Read);
                    m_objISO14443A_Ultralight_Read.Show();
                    break;

                // Ultralight Write
                case "Ultralight_Write":
                    m_objISO14443A_Ultralight_Write.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_Ultralight_Write);
                    m_objISO14443A_Ultralight_Write.Show();
                    break;

                // Ultralight C Authenticate
                case "UltralightC_Auth":
                    m_objISO14443A_UltralightC_Auth.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_UltralightC_Auth);
                    m_objISO14443A_UltralightC_Auth.Show();
                    break;

                // Ultralight C Read
                case "UltralightC_Read":
                    m_objISO14443A_UltralightC_Read.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_UltralightC_Read);
                    m_objISO14443A_UltralightC_Read.Show();
                    break;

                // Ultralight C Write
                case "UltralightC_Write":
                    m_objISO14443A_UltralightC_Write.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objISO14443A_UltralightC_Write);
                    m_objISO14443A_UltralightC_Write.Show();
                    break;

                // Desfire Get Version
                case "DS_PICC_GetVersion":
                    m_objDesfire_GetVersion.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_GetVersion);
                    m_objDesfire_GetVersion.Show();
                    break;

                // Desfire Select Application
                case "DS_PICC_SelectApplication":
                    m_objDesfire_SelectApplication.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_SelectApplication);
                    m_objDesfire_SelectApplication.Show();
                    break;

                // Desfire Get Key Version
                case "DS_Security_GetKeyVersion":
                    m_objDesfire_GetKeyVersion.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_GetKeyVersion);
                    m_objDesfire_GetKeyVersion.Show();
                    break;

                // Desfire Get Key Settings
                case "DS_PICC_GetKeySettings":
                    m_objDesfire_GetKeySetting.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_GetKeySetting);
                    m_objDesfire_GetKeySetting.Show();
                    break;

                // Desfire Authenticate
                case "DS_Security_Authenticate":
                    m_objDesfire_Authenticate.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_Authenticate);
                    m_objDesfire_Authenticate.Show();
                    break;

                // Desfire Get Application IDS
                case "DS_PICC_GetApplicationIDS":
                    m_objDesfire_GetApplicationIDS.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_GetApplicationIDS);
                    m_objDesfire_GetApplicationIDS.Show();
                    break;

                // Desfire Delete Application
                case "DS_PICC_DeleteApplication":
                    m_objDesfire_DeleteApplication.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_DeleteApplication);
                    m_objDesfire_DeleteApplication.Show();
                    break;

                // Desfire Create Application
                case "DS_PICC_CreateApplication":
                    m_objDesfire_CreateApplication.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_CreateApplication);
                    m_objDesfire_CreateApplication.Show();
                    break;

                // Desfire Free Memory
                case "DS_PICC_FreeMemory":
                    m_objDesfire_FreeMemory.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_FreeMemory);
                    m_objDesfire_FreeMemory.Show();
                    break;

                // Desfire Format PICC
                case "DS_PICC_FormatPICC":
                    m_objDesfire_FormatPICC.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_FormatPICC);
                    m_objDesfire_FormatPICC.Show();
                    break;

                // Desfire Change Key Settings
                case "DS_Security_ChangeKeySettings":
                    m_objDesfire_ChangeKeySettings.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_ChangeKeySettings);
                    m_objDesfire_ChangeKeySettings.Show();
                    break;

                // Desfire Change Key
                case "DS_Security_ChangeKey":
                    m_objDesfire_ChangeKey.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_ChangeKey);
                    m_objDesfire_ChangeKey.Show();
                    break;

                // Desfire Get File IDs
                case "DS_APP_GetFileIDS":
                    m_objDesfire_GetFileIDs.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_GetFileIDs);
                    m_objDesfire_GetFileIDs.Show();
                    break;

                // Desfire Create Standard Data File
                case "DS_APP_CreateStdDataFile":
                    m_objDesfire_CreateStdDataFile.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_CreateStdDataFile);
                    m_objDesfire_CreateStdDataFile.Show();
                    break;

                // Desfire Delete File
                case "DS_APP_DeleteFile":
                    m_objDesfire_DeleteFile.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_DeleteFile);
                    m_objDesfire_DeleteFile.Show();
                    break;

                // Desfire Create Backup Data File
                case "DS_APP_CreateBackupDataFile":
                    m_objDesfire_CreateBackupDataFile.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_CreateBackupDataFile);
                    m_objDesfire_CreateBackupDataFile.Show();
                    break;

                // Desfire Create Value File
                case "DS_APP_CreateValueFile":
                    m_objDesfire_CreateValueFile.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_CreateValueFile);
                    m_objDesfire_CreateValueFile.Show();
                    break;

                // Desfire Create Linear Record File
                case "DS_APP_CreateLinearRecordFile":
                    m_objDesfire_CreateLinearRecordFile.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_CreateLinearRecordFile);
                    m_objDesfire_CreateLinearRecordFile.Show();
                    break;

                // Desfire Create Cyclic Record File
                case "DS_APP_CreateCyclicRecordFile":
                    m_objDesfire_CreateCyclicRecordFile.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_CreateCyclicRecordFile);
                    m_objDesfire_CreateCyclicRecordFile.Show();
                    break;

                // Desfire Get File Setting
                case "DS_APP_GetFileSettings":
                    m_objDesfire_GetFileSetting.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_GetFileSetting);
                    m_objDesfire_GetFileSetting.Show();
                    break;

                // Desfire Change File Setting
                case "DS_APP_ChangeFileSettings":
                    m_objDesfire_ChangeFileSetting.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_ChangeFileSetting);
                    m_objDesfire_ChangeFileSetting.Show();
                    break;

                // Desfire Commit Transaction
                case "DS_Data_Commit_Transation":
                    m_objDesfire_CommitTransaction.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_CommitTransaction);
                    m_objDesfire_CommitTransaction.Show();
                    break;

                // Desfire Abort Transaction
                case "DS_Data_AbortTransaction":
                    m_objDesfire_AbortTransaction.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_AbortTransaction);
                    m_objDesfire_AbortTransaction.Show();
                    break;

                // Desfire Get Value
                case "DS_Data_GetValue":
                    m_objDesfire_GetValue.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_GetValue);
                    m_objDesfire_GetValue.Show();
                    break;  

                // Desfire Credit
                case "DS_Data_Credit":
                    m_objDesfire_Credit.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_Credit);
                    m_objDesfire_Credit.Show();
                    break;

                // Desfire Dedit
                case "DS_Data_Debit":
                    m_objDesfire_Debit.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_Debit);
                    m_objDesfire_Debit.Show();
                    break;

                // Desfire Limited Credit
                case "DS_Data_LimitedCredit":
                    m_objDesfire_LimitedCredit.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_LimitedCredit);
                    m_objDesfire_LimitedCredit.Show();
                    break;

                // Desfire Read Records
                case "DS_Data_ReadRecords":
                    m_objDesfire_ReadRecords.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_ReadRecords);
                    m_objDesfire_ReadRecords.Show();
                    break;

                // Desfire Write Records
                case "DS_Data_WriteRecord":
                    m_objDesfire_WriteRecords.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_WriteRecords);
                    m_objDesfire_WriteRecords.Show();
                    break;

                // Desfire Clear Record File
                case "DS_Data_ClearRecordFile":
                    m_objDesfire_ClearRecordFile.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_ClearRecordFile);
                    m_objDesfire_ClearRecordFile.Show();
                    break;

                // Desfire Write Data
                case "DS_Data_WriteData":
                    m_objDesfire_WriteData.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_WriteData);
                    m_objDesfire_WriteData.Show();
                    break;

                // Desfire Read Data
                case "DS_Data_ReadData":
                    m_objDesfire_ReadData.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objDesfire_ReadData);
                    m_objDesfire_ReadData.Show();
                    break;

                // Topaz Get UID
                case "Topaz_GetUID":
                    m_objTopaz_GetUID.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objTopaz_GetUID);
                    m_objTopaz_GetUID.Show();
                    break;

                // Topaz Read Block
                case "Topaz_ReadData":
                    m_objTopaz_ReadBlock.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objTopaz_ReadBlock);
                    m_objTopaz_ReadBlock.Show();
                    break;

                // Topaz Write Block
                case "Topaz_WriteData":
                    m_objTopaz_WriteBlock.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objTopaz_WriteBlock);
                    m_objTopaz_WriteBlock.Show();
                    break;

                // PayWave Get UID
                case "PayWave_GetUID":
                    m_objPayWave_GetUID.TopLevel = false;
                    pnlISO14443A.Controls.Add(m_objPayWave_GetUID);
                    m_objPayWave_GetUID.Show();
                    break;

                default:
                    break;
            }
        }

        // Select Protocol By ISO15693
        private void btnISO15693_SetProtocol_Click(object sender, EventArgs e)
        {
            for (Int32 i32Lp = 0; i32Lp < tabMain.TabCount; i32Lp++)
                if (tabMain.TabPages[i32Lp].Text != "ISO7816")
                    tabMain.TabPages[i32Lp].ImageIndex = 0;

            m_bSettingProtocol = true;

            g_objSDK.General_SelectProtocol(cls_MP_SDK.CommunicationProtocol.ISO15693);

            try
            {
                if (g_objSDK.RxData[5] == 0x01) tabMain.TabPages[2].ImageIndex = 1;
            }
            catch { }
        }

        // Send ISO15693 Command
        private void btnISO15693_Command_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = false;

            trvISO15693.Focus();
            try
            {
                //
                switch (trvISO15693.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        g_objSDK.ISO15693_GetUID();
                        m_vResult_ISO15693_GetUID();
                        break;

                    // Read Block
                    case "Standard_Read":
                        g_objSDK.ISO15693_Read(m_objISO15693_ReadBlock.GetBlock());
                        m_vResult_ISO15693_Read();
                        break;

                    // Wirte Block
                    case "Standard_Write":
                        g_objSDK.ISO15693_Write(m_objISO15693_WriteBlock.GetBlock(), m_objISO15693_WriteBlock.GetData());
                        m_vResult_ISO15693_Write();
                        break;
                }

            }
            catch { return; }
        }

        // Select ISO15693 Command
        private void trvISO15693_AfterSelect(object sender, TreeViewEventArgs e)
        {
            pnlISO15693.Controls.Clear();

            // Show Command Form
            switch (e.Node.Name)
            {
                // Get UID
                case "Standard_GetUID":
                    m_objISO15693_GetUID.TopLevel = false;
                    pnlISO15693.Controls.Add(m_objISO15693_GetUID);
                    m_objISO15693_GetUID.Show();
                    break;

                // Read Block
                case "Standard_Read":
                    m_objISO15693_ReadBlock.TopLevel = false;
                    pnlISO15693.Controls.Add(m_objISO15693_ReadBlock);
                    m_objISO15693_ReadBlock.Show();
                    break;

                // Write Block
                case "Standard_Write":
                    m_objISO15693_WriteBlock.TopLevel = false;
                    pnlISO15693.Controls.Add(m_objISO15693_WriteBlock);
                    m_objISO15693_WriteBlock.Show();
                    break;

                default:
                    break;
            }
        }

        // 
        private void frmMain_Load(object sender, EventArgs e)
        {
            // Hide Felica
            //tabMain.TabPages.RemoveAt(4);
        }

        // Select Protocol By PicoTag
        private void btnPicoTag_SetProtocol_Click(object sender, EventArgs e)
        {
            for (Int32 i32Lp = 0; i32Lp < tabMain.TabCount; i32Lp++)
                if (tabMain.TabPages[i32Lp].Text != "ISO7816")
                    tabMain.TabPages[i32Lp].ImageIndex = 0;

            m_bSettingProtocol = true;

            if (rdoISO15693.Checked == true)
            {
                g_objSDK.General_SelectProtocol(cls_MP_SDK.CommunicationProtocol.PicoTag_ISO15693);
            }
            else
            {
                g_objSDK.General_SelectProtocol(cls_MP_SDK.CommunicationProtocol.PicoTag_ISO14443B);  
            }

            try
            {
                if (g_objSDK.RxData[5] == 0x01) tabMain.TabPages[3].ImageIndex = 1;
            }
            catch { }
        }

        // Select PictoTag Command
        private void trvPicoTag_AfterSelect(object sender, TreeViewEventArgs e)
        {
            pnlPicoTag.Controls.Clear();

            // Show Command Form
            switch (e.Node.Name)
            {
                // Get UID
                case "Standard_GetUID":
                    m_objPicoTag_GetUID.TopLevel = false;
                    pnlPicoTag.Controls.Add(m_objPicoTag_GetUID);
                    m_objPicoTag_GetUID.Show();
                    break;

                // Read Block
                case "Standard_Read":
                    m_objPicotag_Read.TopLevel = false;
                    pnlPicoTag.Controls.Add(m_objPicotag_Read);
                    m_objPicotag_Read.Show();
                    break;

                default:
                    break;
            }
        }

        // Send PicoTag Commmand
        private void btnISOPicoTag_Command_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = false;

            trvPicoTag.Focus();

            try
            {

                // Show Command Form
                switch (trvPicoTag.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        g_objSDK.PicoTag_GetUID();
                        m_vResult_PicoTag_GetUID();
                        break;

                    // Read Block
                    case "Standard_Read":
                        g_objSDK.PicoTag_Read(m_objPicotag_Read.GetBlock());
                        m_vResult_PicoTag_Read();
                        break;

                    default:
                        break;
                }
            }
            catch { return; }
        }

        // Select ISO14443B Command
        private void trvISO14443B_AfterSelect(object sender, TreeViewEventArgs e)
        {
            pnlISO14443B.Controls.Clear();

            // Show Command Form
            switch (e.Node.Name)
            {
                // Get UID
                case "Standard_GetUID":
                    m_objISO14443B_GetUID.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443B_GetUID);
                    m_objISO14443B_GetUID.Show();
                    break;

                // ATTRIB
                case "Standard_ATTRIB":
                    m_objISO14443B_ATTRIB.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443B_ATTRIB);
                    m_objISO14443B_ATTRIB.Show();
                    break;

                // APDU
                case "Standard_APDU":
                    m_objISO14443B_APDU.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443B_APDU);
                    m_objISO14443B_APDU.Show();
                    break;

                // Deselect 
                case "Standard_Deselect":
                    m_objISO14443B_Deselect.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443B_Deselect);
                    m_objISO14443B_Deselect.Show();
                    break;

                // Cepas UID
                case "Cepas_GetUID":
                    m_objISO14443B_Cepas_GetUID.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443B_Cepas_GetUID);
                    m_objISO14443B_Cepas_GetUID.Show();
                    break;

                // SRI Get UID
                case "SRI_GetUID":
                    m_objISO14443B_SRI_GetUID.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443B_SRI_GetUID);
                    m_objISO14443B_SRI_GetUID.Show();
                    break;

                // SRI Read Block
                case "SRI_Read":
                    m_objISO14443_SRI_ReadBlock.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443_SRI_ReadBlock);
                    m_objISO14443_SRI_ReadBlock.Show();
                    break;

                // SRI Write Block
                case "SRI_Write":
                    m_objISO14443_SRI_WriteBlock.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443_SRI_WriteBlock);
                    m_objISO14443_SRI_WriteBlock.Show();
                    break;

                // PayWave Get UID
                case "PayWave_GetUID":
                    m_objISO14443_PayWave_GetUID.TopLevel = false;
                    pnlISO14443B.Controls.Add(m_objISO14443_PayWave_GetUID);
                    m_objISO14443_PayWave_GetUID.Show();
                    break;

                default:
                    break;
            }
        }

        // Select Protocol By ISO14443B
        private void button4btnISO14443B_SetProtocol_Click(object sender, EventArgs e)
        {
            for (Int32 i32Lp = 0; i32Lp < tabMain.TabCount; i32Lp++)
                if (tabMain.TabPages[i32Lp].Text != "ISO7816")
                    tabMain.TabPages[i32Lp].ImageIndex = 0;

            m_bSettingProtocol = true;

            g_objSDK.General_SelectProtocol(cls_MP_SDK.CommunicationProtocol.ISO14443B);

            try
            {
                if (g_objSDK.RxData[5] == 0x01) tabMain.TabPages[1].ImageIndex = 1;
            }
            catch { }
        }

        // Send ISO14443B Command
        private void btnISO14443B_Command_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = false;

            trvISO14443B.Focus();

            try
            {

                // Show Command Form
                switch (trvISO14443B.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        g_objSDK.ISO14443B_GetUID();
                        m_vResult_ISO14443B_GetUID();
                        break;

                    // ATTRIB
                    case "Standard_ATTRIB":
                        g_objSDK.ISO14443B_ATTRIB();
                        m_vResult_ISO14443B_ATTRIB();
                        break;

                    // APDU 
                    case "Standard_APDU":
                        g_objSDK.ISO14443B_APDU(m_objISO14443B_APDU.GetCommand());
                        m_vResult_ISO14443B_APDU();
                        break;

                    // Deselect
                    case "Standard_Deselect":
                        g_objSDK.ISO14443B_Deselect();
                        m_vResult_ISO14443B_Deselect();
                        break;

                    // Cepas Get UID
                    case "Cepas_GetUID":
                        g_objSDK.ISO14443B_Cepas_GetUID();
                        m_vResult_ISO14443B_Cepas_GetUID();
                        break;

                    // SRI Get UID
                    case "SRI_GetUID":
                        g_objSDK.ISO14443B_SRI_GetUID();
                        m_vResult_ISO14443B_SRI_GetUID();
                        break;

                    // SRI Read
                    case "SRI_Read":
                        g_objSDK.ISO14443B_SRI_Read(m_objISO14443_SRI_ReadBlock.GetBlock());
                        m_vResult_ISO14443B_SRI_Read();
                        break;

                    // SRI Write
                    case "SRI_Write":
                        g_objSDK.ISO14443B_SRI_Write(m_objISO14443_SRI_WriteBlock.GetBlock(), m_objISO14443_SRI_WriteBlock.GetData());
                        m_vResult_ISO14443B_SRI_Write();
                        break;

                    // PayWave Get UID
                    case "PayWave_GetUID":
                        g_objSDK.ISO14443B_PayWave_GetUID();
                        m_vResult_ISO14443B_PayWave_GetUID();
                        break;
                    
                    default:
                        break;
                }
            }
            catch { }
        }

        // Mifare Access Condition
        private void mnuMifareAC_Click(object sender, EventArgs e)
        {
            frmMifareAccessCondition objForm = new frmMifareAccessCondition();

            objForm.ShowDialog();
        }

        // Enable Auto Polling
        private void mnuAutoPolling_Enable_Click(object sender, EventArgs e)
        {
            g_objSDK.General_AutoPolling(cls_MP_SDK.AutoPolling.Enable);
        }

        // Disable Auto Polling
        private void mnuAutoPolling_Disable_Click(object sender, EventArgs e)
        {
            g_objSDK.General_AutoPolling(cls_MP_SDK.AutoPolling.Disable);
        }

        // Select ISO7816 Command
        private void trvISO7816_AfterSelect(object sender, TreeViewEventArgs e)
        {
            pnlISO7816.Controls.Clear();

            // Show Command Form
            switch (e.Node.Name)
            {
                // Get ATS
                case "Standard_RATS":
                    m_objISO7816_GetATS.TopLevel = false;
                    pnlISO7816.Controls.Add(m_objISO7816_GetATS);
                    m_objISO7816_GetATS.Show();
                    break;

                // APDU
                case "Standard_APDU":
                    m_objISO7816_APDU.TopLevel = false;
                    pnlISO7816.Controls.Add(m_objISO7816_APDU);
                    m_objISO7816_APDU.Show();
                    break;

                //
                case "Taiwan_HealthIC":
                    m_objISO7816_Special_TaiwanHealthIC.TopLevel = false;
                    pnlISO7816.Controls.Add(m_objISO7816_Special_TaiwanHealthIC);
                    m_objISO7816_Special_TaiwanHealthIC.Show();
                    break;
                default:
                    break;
            }
        }

        // Send ISO7816 Command
        private void btnISO7816_Command_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = false;

            System.Windows.Forms.TextBox txtResponse;
            Byte[] byData;
            Byte[] SelectFile_ForTaiwanHealthIC = { 0x00, 0xa4, 0x04, 0x00, 0x10, 0xd1, 0x58, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x11, 0x00 };
            Byte[] ReadICData = {0x00 ,0xca ,0x11 ,0x00 ,0x02 ,0x00 ,0x00};
            trvISO7816.Focus();

            try
            {
                // Show Command Form
                switch (trvISO7816.SelectedNode.Name)
                {
                    // Get ATS
                    case "Standard_RATS":
                        g_objSDK.ISO7816_GetATS();
                        m_vResult_ISO7816_GetATR();
                        break;

                    // APDU
                    case "Standard_APDU":
                        g_objSDK.ISO7816_APDU(m_objISO7816_APDU.GetCommand());
                        m_vResult_ISO7816_APDU();
                        break;

                    // APDU
                    case "Taiwan_HealthIC":

                        g_objSDK.ISO7816_GetATS();

                        if (g_objSDK.RxData == null) return;

                        byData = g_objSDK.RxData;

                        // Request
                        txtResponse = m_objISO7816_Special_TaiwanHealthIC.txtResponse;

                        txtResponse.Text = "";

                        if (byData.Length <= 0) { txtResponse.Text = ""; return; }

                        if (byData[5] == 0xE0)
                        {
                            txtResponse.Text = "No Response";
                            return;
                        }

                        if (byData[5] != 0x01)
                        {
                            txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                            txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                            return;
                        }

                        g_objSDK.ISO7816_APDU(SelectFile_ForTaiwanHealthIC);

                         if (g_objSDK.RxData == null) return;

                        byData = g_objSDK.RxData;

                        // Request
                        txtResponse = m_objISO7816_Special_TaiwanHealthIC.txtResponse;

                        txtResponse.Text = "";

                        if (byData.Length <= 0) { txtResponse.Text = ""; return; }

                        if (byData[5] == 0xE0)
                        {
                            txtResponse.Text = "No Response";
                            return;
                        }

                        if (byData[5] != 0x01)
                        {
                            txtResponse.Text = "Response Error:" + byData[5].ToString("X2");
                            txtResponse.Text += Environment.NewLine + GetReaderErrorName(byData[5]);
                            return;
                        }

                        if (byData[5] == 0x01 && byData[6] == 0x90 && byData[7] == 0x00)
                        {
                            g_objSDK.ISO7816_APDU(ReadICData);
                        }
                        else
                        {
                            return;
                        }
                        m_vResult_ISO7816_Special_HealthIC_Taiwan();
                        

                        break;
                    default:
                        break;
                }
            }
            catch { return; }
        }

        // Select Protocol By Felica
        private void btnFelica_SetProtocol_Click(object sender, EventArgs e)
        {
            for (Int32 i32Lp = 0; i32Lp < tabMain.TabCount; i32Lp++)
                if (tabMain.TabPages[i32Lp].Text != "ISO7816")
                    tabMain.TabPages[i32Lp].ImageIndex = 0;

            m_bSettingProtocol = true;

            g_objSDK.General_SelectProtocol(cls_MP_SDK.CommunicationProtocol.Felica);

            try
            {
                if (g_objSDK.RxData[5] == 0x01) tabMain.TabPages[4].ImageIndex = 1;
            }
            catch { }
        }

        // Send Felica Command
        private void btnISOFelica_Command_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = false;

            trvFelica.Focus();
            try
            {
                //
                switch (trvFelica.SelectedNode.Name)
                {
                    // Get UID
                    case "Standard_GetUID":
                        g_objSDK.Felica_GetUID(m_objFelica_GetUID.GetSystemCode(), m_objFelica_GetUID.GetReserved());
                        m_vResult_Felica_GetUID();
                        break;

                 
                }

            }
            catch { return; }
        }

        // 
        private void trvFelica_AfterSelect(object sender, TreeViewEventArgs e)
        {
            pnlFelica.Controls.Clear();

            // Show Command Form
            switch (e.Node.Name)
            {
                // Get UID
                case "Standard_GetUID":
                    m_objFelica_GetUID.TopLevel = false;
                    pnlFelica.Controls.Add(m_objFelica_GetUID);
                    m_objFelica_GetUID.Show();
                    break;

             

                default:
                    break;
            }
        }

        // Set P2P Protocol
        private void btnP2P_SetProtocol_Click(object sender, EventArgs e)
        {
            for (Int32 i32Lp = 0; i32Lp < tabMain.TabCount; i32Lp++)
                if (tabMain.TabPages[i32Lp].Text != "ISO7816")
                    tabMain.TabPages[i32Lp].ImageIndex = 0;

            m_bSettingProtocol = true;

            if (radInitiator.Checked == true)
                g_objSDK.P2P_SetMode(cls_MP_SDK.P2P_Mode.Initiator);
            else
                g_objSDK.P2P_SetMode(cls_MP_SDK.P2P_Mode.Target);

            try
            {
                if (g_objSDK.RxData[5] == 0x01) tabMain.TabPages[6].ImageIndex = 1;
            }catch{return;}
        }

        // Send P2P Command
        private void btnP2P_Command_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = false;

            trvP2P.Focus();

            try
            {
                // Show Command Form
                switch (trvP2P.SelectedNode.Name)
                {
                    // Send Data
                    case "Standard_SendData":
                        g_objSDK.P2P_SendData(m_objP2P_SendData.GetCommand());
                        m_vResult_P2P_SendData();
                        break;

                    // Get Data
                    case "Standard_GetData":
                        //g_objSDK.P2P_GetData();
                        //g_objSDK.ISO7816_APDU(m_objISO7816_APDU.GetCommand());
                        //m_vResult_ISO7816_APDU();
                        break;

                    default:
                        break;
                }
            }
            catch { return; }
        }

        private void trvP2P_AfterSelect(object sender, TreeViewEventArgs e)
        {
            pnlP2P.Controls.Clear();

            // Show Command Form
            switch (e.Node.Name)
            {
                // Get ATS
                case "Standard_SendData":
                    m_objP2P_SendData.TopLevel = false;
                    pnlP2P.Controls.Add(m_objP2P_SendData);
                    m_objP2P_SendData.Show();
                    break;

                // APDU
                case "Standard_GetData":
                    //m_objISO7816_APDU.TopLevel = false;
                    //pnlP2P.Controls.Add(m_objISO7816_APDU);
                    //m_objISO7816_APDU.Show();
                    break;

                default:
                    break;
            }
        }

        // Send Data To Audio
        private void btnSendDataToAudio_Click(object sender, EventArgs e)
        {
            /*
            txtAudioData.Text = txtAudioData.Text.Replace(" ", "");

            Byte[] Data = new Byte[(txtAudioData.Text.Length / 2)];

            for (Int32 i32Lp = 0; i32Lp < (txtAudioData.Text.Length / 2) ; i32Lp++)
            {
                Data[i32Lp] = Convert.ToByte(txtAudioData.Text.Substring(i32Lp * 2, 2), 16);
            }
            */
            g_objSDK.General_Test(null);
            //if(txtAudioData.Text.Length <= 0) return;

            //if(txtAudioData.Text.Length % 2 != 0) return;

            //Byte[] Data = new Byte[(txtAudioData.Text.Length / 2)];
            /*
            Byte[] Data = new Byte[255];
            
            try
            {
                /*
                for (Int32 i32Lp = 0; i32Lp < (txtAudioData.Text.Length / 2) ; i32Lp++)
                {
                    Data[i32Lp] = Convert.ToByte(txtAudioData.Text.Substring(i32Lp * 2, 2), 16);
                }
                
                for (Int32 i32Lp = 0; i32Lp < 255; i32Lp++)
                {
                    Data[i32Lp] = (Byte)i32Lp;
                }
            }
            catch{return;}
            */
            //g_objSDK.General_Test(Data);
        }
        
        // Configuration Port
        private void mnu_Port_Config_Click(object sender, EventArgs e)
        {
            frmPortConfig objForm = new frmPortConfig();

            objForm.g_i32Baudrate = spMain.BaudRate;

            objForm.ShowDialog();

            spMain.BaudRate = objForm.g_i32Baudrate;
        }

        // Turn On LED1
        private void mnuLED1On_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = true;
            g_objSDK.General_LED_Control(0x00, (cls_MP_SDK.LED_State) 0x00);
        }

        // Turn Off LED1
        private void mnuLED1Off_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = true;
            g_objSDK.General_LED_Control(0x00, (cls_MP_SDK.LED_State)0x01);
        }

        // Turn On LED2
        private void mnuLED2On_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = true;
            g_objSDK.General_LED_Control(0x01, (cls_MP_SDK.LED_State)0x00);
        }

        // Turn Off LED2
        private void mnuLED2Off_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = true;
            g_objSDK.General_LED_Control(0x01, (cls_MP_SDK.LED_State)0x01);
        }

        // Trigger Buzzer
        private void mnuBuzzerTrigger_Click(object sender, EventArgs e)
        {
            m_bSettingProtocol = true;
            g_objSDK.General_Buzzer_Control();
        }

        // Reset Reader
        private void mnuReset_Click(object sender, EventArgs e)
        {
            g_objSDK.General_Reset();
        }

        // Update BootLoader
        private void mnuUpdateBootloader_Click(object sender, EventArgs e)
        {
            OpenFileDialog objFile = new OpenFileDialog();

            if (spMain.IsOpen == false) return;

            objFile.Filter = "Firmware File|*.bin";

            if (objFile.ShowDialog() != DialogResult.OK) return;

            frmUpdateFirmware_Hardware objForm = new frmUpdateFirmware_Hardware();

            //g_objSDK.StopUartReceiveEvent();

            //objForm.g_ojSDK = g_objSDK;
            objForm.spModem = spMain;
            objForm.g_strFlilName = objFile.FileName;

            Int32 i32Baudrate = spMain.BaudRate;

            objForm.ShowDialog();

            //g_objSDK.StartUartReceiveEvent();

            g_objSDK.CommunicationLogs = "";

            txtCommunicationLogs.Text = "";

            spMain.BaudRate = i32Baudrate;
            spMain.Parity = System.IO.Ports.Parity.None;
        }

       
    }
}
