﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using libMpSDK;

namespace MP_SDK_Demo
{
    public partial class frmUpdateFirmware : Form
    {
        // YModem Protocol Command Define
        private const Byte SOH = 0x01;
        private const Byte STX = 0x02;
        private const Byte EOT = 0x04;
        private const Byte ACK = 0x06;
        private const Byte NAK = 0x15;
        private const Byte CAN = 0x18;
        private const Byte C = 0x43;

        public System.IO.Ports.SerialPort spYModem;

        public String g_strFlilName = "";

        public cls_MP_SDK g_ojSDK;

        public frmUpdateFirmware()
        {
            InitializeComponent();
        }

        private void frmUpdateFirmware_Shown(object sender, EventArgs e)
        {
            this.Refresh();

            Byte[] byarrCmd = { SOH, 0x00, 0xFF };

            Byte[] byarrUpdate = { 0xAE,0x00,0x02,0x00,0xFF,0xFD };

            Byte[] byarrData = new Byte[128];

            Byte[] byarrCRC = { 0x00, 0x00 };

            Int32 i32ByteInx;

            spYModem.ReadTimeout = 3000;

            // Change To Boot
            labStatus.Text = "Changing To Boot...";
            labStatus.Refresh();

            spYModem.Write(byarrUpdate, 0, 6);

            System.Threading.Thread.Sleep(2000);

            spYModem.BaudRate = 19200;
            spYModem.Parity = System.IO.Ports.Parity.None;
            spYModem.DataBits = 8;

            labStatus.Text = "Updating...";
            labStatus.Refresh();

            // Clear Data
            for (Int32 i32Lp = 0; i32Lp < 128; i32Lp++)
                byarrData[i32Lp] = 0x00;

            spYModem.Write(((Char)0x0D).ToString());

            while (true)
            {
                try
                {
                    {
                        Byte[] byData = new Byte[2];
                        byData[0] = (Byte)spYModem.ReadByte();
                        //txtMessage.Text += System.Text.Encoding.ASCII.GetString(byData, 0, 1);
                    }
                }
                catch { break; }
            }

            spYModem.Write("1");

            // Recieve The "C"
            while (true)
            {
                try
                {
                    if (spYModem.ReadByte() == C) break;
                }
                catch
                {
                    MessageBox.Show("Please try again.", "Caption", MessageBoxButtons.OK);
                    this.Close();
                    return;
                }

            }


            String strFileName = "ROM-T1285.bin";

            // 取得 Byte 
            Byte[] byarrFile = System.IO.File.ReadAllBytes(g_strFlilName);

            // 取得總數
            Int32 i32DataLen = byarrFile.Length;
            String strDataLen = i32DataLen.ToString();

            i32ByteInx = 0;

            // 將檔案名稱放入 Data
            for (Int32 i32Lp = 0; i32Lp < strFileName.Length; i32Lp++)
            {
                byarrData[i32ByteInx] = (Byte)Convert.ToChar(strFileName.Substring(i32Lp, 1));
                i32ByteInx += 1;
            }

            i32ByteInx += 1;

            // 將檔案長度名稱放入 Data
            for (Int32 i32Lp = 0; i32Lp < strDataLen.Length; i32Lp++)
            {
                byarrData[i32ByteInx] = (Byte)Convert.ToChar(strDataLen.Substring(i32Lp, 1));
                i32ByteInx += 1;
            }

            // Get CRC
            byarrCRC = m_byarCRC(byarrData);

            // 第一個封包
            spYModem.Write(byarrCmd, 0, 3);
            spYModem.Write(byarrData, 0, 128);
            spYModem.Write(byarrCRC, 0, 2);

            while (true)
            { if (spYModem.ReadByte() == ACK) break; }

            Int32 i32FrameInx = 1;

            pgStatus.Maximum = byarrFile.Length;

            for (Int32 i32Inx = 0; i32Inx < byarrFile.Length; i32Inx += 128)
            {
                this.Refresh();

                // Clear Data
                for (Int32 i32Lp = 0; i32Lp < 128; i32Lp++)
                { byarrData[i32Lp] = 0x00; }

                // Set Data
                for (Int32 i32Lp = 0; i32Lp < 128; i32Lp++)
                {
                    byarrData[i32Lp] = byarrFile[i32Lp + i32Inx];

                    pgStatus.Value = i32Lp + i32Inx + 1;

                    if ((i32Lp + i32Inx) == (byarrFile.Length - 1)) break;
                }

                // Get CRC
                byarrCRC = m_byarCRC(byarrData);

                byarrCmd[1] = Convert.ToByte(i32FrameInx);
                byarrCmd[2] = Convert.ToByte((0xFF - i32FrameInx));

                // Data
                spYModem.Write(byarrCmd, 0, 3);
                spYModem.Write(byarrData, 0, 128);
                spYModem.Write(byarrCRC, 0, 2);

                try
                {
                    while (true)
                    { if (spYModem.ReadByte() == ACK) break; }

                    if (i32FrameInx == 0xFF)
                    {
                        i32FrameInx = 0;
                        continue;
                    }
                }
                catch
                {
                    MessageBox.Show("Please try update bootloader.", "Caption", MessageBoxButtons.OK);
                    this.Close();
                    return;
                }
                i32FrameInx += 1;
            }

            spYModem.Write(Convert.ToString((Char)EOT));

            while (true)
            { if (spYModem.ReadByte() == ACK) break; }

            // Final Data
            for (Int32 i32Lp = 0; i32Lp < 128; i32Lp++)
                byarrData[i32Lp] = 0x00;

            // Get CRC
            byarrCRC = m_byarCRC(byarrData);

            byarrCmd[1] = 0x00;
            byarrCmd[2] = 0xFF;

            // Data
            spYModem.Write(byarrCmd, 0, 3);
            spYModem.Write(byarrData, 0, 128);
            spYModem.Write(byarrCRC, 0, 2);

            while (true)
            { if (spYModem.ReadByte() == ACK) break; }

            
            labStatus.Text = "Finished";

            spYModem.Write("2");

            spYModem.Close();

            spYModem.Open();

            this.Close();

        }

        private Byte[] m_byarCRC(Byte[] byarrData)
        {
            Byte[] byarrCRC = { 0x00, 0x00 };
            Int32 i32CRC;

            i32CRC = CRC16.CRC16_ccitt(byarrData, 0, 128);

            byarrCRC[1] = Convert.ToByte(i32CRC & 0x000000FF);

            i32CRC = i32CRC >> 8;

            byarrCRC[0] = Convert.ToByte(i32CRC & 0x000000FF);

            return byarrCRC;
        }
    }
}
